给定一个数组,它的第 i 个元素是一支给定的股票在第 i 天的价格。
设计一个算法来计算你所能获取的最大利润。你最多可以完成 两笔 交易。
注意: 你不能同时参与多笔交易(你必须在再次购买前出售掉之前的股票)。
示例 1:
输入: [3,3,5,0,0,3,1,4]
输出: 6
解释: 在第 4 天(股票价格 = 0)的时候买入,在第 6 天(股票价格 = 3)的时候卖出,这笔交易所能获得利润 = 3-0 = 3 。
随后,在第 7 天(股票价格 = 1)的时候买入,在第 8 天 (股票价格 = 4)的时候卖出,这笔交易所能获得利润 = 4-1 = 3 。
示例 2:
输入: [1,2,3,4,5]
输出: 4
解释: 在第 1 天(股票价格 = 1)的时候买入,在第 5 天 (股票价格 = 5)的时候卖出, 这笔交易所能获得利润 = 5-1 = 4 。
注意你不能在第 1 天和第 2 天接连购买股票,之后再将它们卖出。
因为这样属于同时参与了多笔交易,你必须在再次购买前出售掉之前的股票。
示例 3:
输入: [7,6,4,3,1]
输出: 0
解释: 在这个情况下, 没有交易完成, 所以最大利润为 0。
来源:力扣(LeetCode)
链接:https://leetcode-cn.com/problems/best-time-to-buy-and-sell-stock-iii
著作权归领扣网络所有。商业转载请联系官方授权,非商业转载请注明出处。
第一种思路:
把数组分为两个部分,每个部分调用LeetCode-Python-121. 买卖股票的最佳时机的解答,合在一起即为完成两笔交易的盈利。
问题:有点慢,只能过199/200个CASE。
class Solution(object):
def maxProfit(self, prices):
"""
:type prices: List[int]
:rtype: int
"""
res = 0
for i in range(len(prices)):
res = max(res, self.maxProfit1(prices[:i]) + self.maxProfit1(prices[i:]))
return res
def maxProfit1(self, prices):
"""
:type prices: List[int]
:rtype: int
"""
if not prices:
return 0
res = 0
for i, price in enumerate(prices):
if i == 0:
min_p = price
else:
res = max(res, price - min_p)
min_p = min(min_p, price)
return res
第二种思路:
动态规划
dp[i][k][0/1]表示第i天交易次数还剩k手上拿着1或者没拿0股票的状态
比如:
dp[2][1][1]表示第二天,还可以交易一次,手上持有股票
dp[3][5][0]表示第三天,还可以交易五次,手上没拿股票
求dp[len(prices) - 1][0][0]
dp[i][k][0] = max(dp[i - 1][k][0], dp[i - 1][k][1] + prices[i])
dp[i][k][1] = max(dp[i - 1][k][1], dp[i - 1][k - 1][0] - prices[i])
class Solution(object):
def maxProfit(self, prices):
"""
:type prices: List[int]
:rtype: int
"""
max_k = 2
n = len(prices)
dp = [[[0 for _ in range(2)] for _ in range(max_k + 1)] for _ in range(n)]
for i, price in enumerate(prices):
for k in range(max_k, 0, -1):
if i == 0:
dp[0][k][0] = 0
dp[0][k][1] = -price
else:
dp[i][k][0] = max(dp[i - 1][k][0], dp[i - 1][k][1] + prices[i])
dp[i][k][1] = max(dp[i - 1][k][1], dp[i - 1][k - 1][0] - prices[i])
return dp[n - 1][max_k][0] if prices else 0